-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : rom_async.vhd
--   Nazev     : Vypis 12.2
--   Popis     : Asynchronni pamet ROM
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity rom_async is
   port (
      adr : in std_logic_vector (3 downto 0);
      data : out std_logic_vector (7 downto 0)
   );
end rom_async;

architecture a_rom_async of rom_async is
   type mem is array (0 to 15) of std_logic_vector (7 downto 0);
   signal rom_block : mem := (X"F1", X"12", X"19", X"72", X"E2", X"D9", X"19",
      X"76", X"26", X"C7", X"2B", X"A3", X"11", X"F1", X"2E", X"D6");
begin
   data <= rom_block(to_integer(unsigned(adr)));
end a_rom_async;

