-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : nepodminene.vhd
--   Nazev     : Vypis 3.2
--   Popis     : Pouziti ruznych variant nepodmineneho prirazeni
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity nepodminene is
   port (
      a, b : out std_logic;
      sirka : out integer;
      sig1, sig2, sig3, sig4, sig5 : out std_logic
   );
end;

architecture a_nepodminene of nepodminene is
   -- deklarace vnitrnich signalu
   signal c, d, sig : std_logic;
begin
   -- pouziti nepodminenych prirazeni (syntetizovatelna)
   a <= not d;
   b <= c xor d;
   c <= '0';
   d <= '1';
   sirka <= 10;
   sig1 <= sig;

   -- pouziti nepodminenych prirazeni (nesyntetizovatelna)
   sig <= '1', '0' after 3 ns, '1' after 6 ns, '0' after 8.5 ns, '1' after 11 ns,
      '0' after 13 ns;
   sig2 <= transport sig after 3 ns;
   sig3 <= sig after 3 ns;
   sig4 <= inertial sig after 3 ns;
   sig5 <= reject 2 ns inertial sig after 3 ns;
end;
