-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : siroky_and.vhd
--   Nazev     : Vypis 3.3
--   Popis     : Uplny zdrojovy text realizujici parametrizovatelny AND
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity siroky_and is
   generic (
      sirka : positive := 64	-- sirka slova
   );
   port (
      data : in std_logic_vector (sirka - 1 downto 0);  -- vstupni vektor dat
      y : out std_logic	-- vystup hradla AND
   );
end siroky_and;


architecture struct of siroky_and is
   signal tmp : std_logic_vector (sirka - 1 downto 0);
begin
   tmp(0) <= data(0);
   wand: for i in 1 to sirka - 1 generate
      tmp(i) <= tmp(i - 1) and data(i);
   end generate wand;
   y <= tmp(sirka - 1);
end struct;
