-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : fibex.vhd
--   Nazev     : Vypis 3.6
--   Popis     : Parametrizovatelny generator Fibonacciho posloupnosti pomoci
--               knihovny LPM
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

library lpm;
use lpm.lpm_components.all;

entity fibex is
   generic (
      sirka : positive := 16
   );
   port (
      clk : in std_logic;
      reset : in std_logic;
      vystup : out std_logic_vector (sirka - 1 downto 0);
      preteceni : out std_logic
   );
end;

architecture struct of fibex is
   signal minula : std_logic_vector (sirka - 1 downto 0);
   signal soucasna : std_logic_vector (sirka - 1 downto 0);
   signal vysledek : std_logic_vector (sirka - 1 downto 0);
begin
   u1 : lpm_ff
      generic map (lpm_width => sirka, lpm_avalue => "0")
      port map (data => vysledek (sirka - 1 downto 0), clock => clk, aset =>
         reset, q => minula);

   u2 : lpm_ff
      generic map (lpm_width => sirka, lpm_avalue => "1")
      port map (data => minula, clock => clk, aset => reset, q => soucasna);

   u3 : lpm_add_sub
      generic map (lpm_width => sirka)
      port map (dataa => soucasna, datab => minula, result => vysledek,
         cout => preteceni);

   vystup <= vysledek;
end;
