-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : seg_lib.vhd
--   Nazev     : Vypis 3.7
--   Popis     : Priklad uzivatelskeho knihovniho baliku
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

package seg_lib is
   component segment is
      port (
         data : in std_logic_vector (3 downto 0);
         seg : out std_logic_vector (6 downto 0)
      );
   end component;

   function slv2str (data : std_logic_vector (3 downto 0)) return string;
end;

package body seg_lib is
   function slv2str (data : std_logic_vector (3 downto 0)) return string is
   begin
      case data is
         when x"0" => return "0";
         when x"1" => return "1";
         when x"2" => return "2";
         when x"3" => return "3";
         when x"4" => return "4";
         when x"5" => return "5";
         when x"6" => return "6";
         when x"7" => return "7";
         when x"8" => return "8";
         when x"9" => return "9";
         when others => return "X";
      end case;
   end;
end;
