-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : add.vhd
--   Nazev     : Vypis 8.12
--   Popis     : Scitacka s vystupem pro prenos realizovana pomoci typu
--               unsigned a operatoru +
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity add is
   generic (
      width : positive := 8   -- sirka slova scitancu
   );
   port (
      a : in std_logic_vector (width - 1 downto 0);   -- 1. scitanec
      b : in std_logic_vector (width - 1 downto 0);   -- 2. scitanec
      s : out std_logic_vector (width - 1 downto 0);   -- vysledny soucet
      cout : out std_logic   -- vystup prenosu (carry out)
   );
end add;
architecture behav of add is
   signal a_uns, b_uns, s_uns : unsigned (width downto 0);
begin
   -- typova konverze na unsigned a rozsireni o 1 bit kvuli vystupu prenosu
   a_uns <= unsigned ('0' & a);
   b_uns <= unsigned ('0' & b);

   -- soucet behavioralne
   s_uns <= a_uns + b_uns;

   -- zpetna typova konverze na std_logic_vector
   s <= std_logic_vector (s_uns(width - 1 downto 0));

   -- vystupni prenos
   cout <= s_uns(width);
end behav;
