-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : add_sub.vhd
--   Nazev     : Vypis 8.13
--   Popis     : Prepinatelna scitacka/odcitacka pomoci rizene negace a
--               operatoru +
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity add_sub is
   generic (
      width : positive := 8   -- sirka slova operandu
   );
   port (
      a : in std_logic_vector (width - 1 downto 0);   -- 1. operand
      b : in std_logic_vector (width - 1 downto 0);   -- 2. operand
      pm : in std_logic;   -- prepinac '0' - add / '1' - sub
      s : out std_logic_vector (width - 1 downto 0)   -- vysledek
   );
end add_sub;
architecture prep_invert_add of add_sub is
   signal a_uns, b_uns, cin_uns, r_uns : unsigned (width - 1 downto 0);
begin
   -- typova konverze na unsigned
   a_uns <= unsigned (a);

   -- rizene negovani druheho op. ('0' - buffer / '1'  invert)
   neg: for i in 0 to width - 1 generate
      b_uns(i) <= b(i) xor pm;
   end generate neg;

   -- vstupni prenos '0' - scitani / '1' - odcitani
   cin_uns(0) <= pm;
   cin_uns(width - 1 downto 1) <= (others => '0');

   -- soucet
   r_uns <= a_uns + b_uns + cin_uns;

   -- zpetna typova konverze na std_logic
   s <= std_logic_vector (r_uns);
end prep_invert_add;
