-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : jk_ff.vhd
--   Nazev     : Vypis 8.21
--   Popis     : Klopny obvod JK rizeny hranou realizovany pomoci procesu a
--               case
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity jk_ff is
   port (
      j : in std_logic;
      k : in std_logic;
      clk : in std_logic;
      q : out std_logic;
      n_q : out std_logic
   );
end jk_ff;

architecture struct of jk_ff is
   signal jk : std_logic_vector (1 downto 0);
begin
   -- slouceni signalu j a k do jednoho dvoubitoveho signalu jk
   jk <= j & k;

   -- proces se spousti pri zmene signalu clk
   process (clk)
      -- promenna udrzujici hodnotu klopneho obvodu
      variable ff : std_logic;
   begin
      if clk'event and clk = '1' then
         -- realizace pravdivostni tabulky klopneho obvodu JK pomoci case
         case jk is
            when "01" =>
               ff := '0';
            when "10" =>
               ff := '1';
            when "11" =>
               ff := not ff;
            when others =>
               null;
         end case;
         -- vystup hodnoty klopneho obvodu na signaly q a n_q
         q <= ff;
         n_q <= not ff;
      end if;
   end process;
end struct;
