-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : t_ff_async.vhd
--   Nazev     : Vypis 8.22
--   Popis     : Asynchronni klopny obvod typu T realizovany pomoci procesu
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity t_ff_async is
   port (
      t : in std_logic;
      r : in std_logic;
      q : out std_logic;
      n_q : out std_logic
   );
end t_ff_async;

architecture struct of t_ff_async is
begin
   -- proces se spousti pri zmene signalu r nebo t
   process (r, t)
      -- promenna udrzujici hodnotu klopneho obvodu
      variable ff : std_logic;
   begin
      -- reset
      if r = '1' then
         ff := '0';
      -- realizace asynchronniho klopneho obvodu T
      elsif t'event and t = '1' then
         ff := not ff;
      end if;
      -- vystup hodnoty klopneho obvodu na signaly q a n_q
      q <= ff;
      n_q <= not ff;
   end process;
end struct;
