-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : t_ff_sync.vhd
--   Nazev     : Vypis 8.23
--   Popis     : Synchronni klopny obvod typu T realizovany pomoci procesu
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity t_ff_sync is
   port (
      t : in std_logic;
      r : in std_logic;
      clk : in std_logic;
      q : out std_logic;
      n_q : out std_logic
   );
end t_ff_sync;

architecture struct of t_ff_sync is
begin
   -- proces se spousti pri zmene signalu clk nebo r
   process (clk, r)
      -- promenna udrzujici hodnotu klopneho obvodu
      variable ff : std_logic;
   begin
      -- asynchronni reset
      if r = '1' then
         ff := '0';
      -- realizace synchronniho klopneho obvodu T
      elsif clk'event and clk = '1' then
         if t = '1' then
            ff := not ff;
         end if;
      end if;
      -- vystup hodnoty klopneho obvodu na signaly q a n_q
      q <= ff;
      n_q <= not ff;
   end process;
end struct;
