-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : dff_up_sr.vhd
--   Nazev     : Vypis 8.24
--   Popis     : Synchronni klopny obvod typu D s asynchronnimi vstupy pro
--               nastaveni a nulovani
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity dff_up_sr is
   port (
      d, clk, r, s : in std_logic;
      q : out std_logic
   );
end dff_up_sr;

architecture struct of dff_up_sr is
begin
   -- proces se spousti pri zmene signalu clk nebo r nebo s
   process (clk, r, s)
   begin
      -- realizace asynchronniho nulovani (ma vetsi prioritu nez nastaveni)
      if r = '0' then
         q <= '0';
      -- realizace asynchronniho nastaveni
      elsif s = '0' then
         q <= '1';
      -- realizace synchronniho klopneho obvodu
      elsif clk'event and clk = '1' then
         q <= d;
      end if;
   end process;
end struct;
