-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : dff_up_en.vhd
--   Nazev     : Vypis 8.25
--   Popis     : Blokovani cinnosti klopneho obvodu
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity dff_up_en is
   port (
      d, clk, en : in std_logic;
      q : buffer std_logic
   );
end dff_up_en;

architecture struct of dff_up_en is
begin
   -- proces se spousti pri zmene signalu clk
   process (clk)
   begin
      -- realizace synchronniho klopneho obvodu
      if clk'event and clk = '1' then
         -- blokovani funkce klopneho obvodu
         if en = '1' then
            q <= d;
         else
            q <= q;
         end if;
      end if;
   end process;
end struct;
