-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : posuv_reg.vhd
--   Nazev     : Vypis 9.3
--   Popis     : Parametrizovatelny posuvny registr s asynchronnim nulovanim a
--               synchronnim nastavenim
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity posuv_reg is
   generic (
      n : positive := 8
   );
   port (
      clk : in std_logic;
      sd : in std_logic;
      n_r : in std_logic;
      pe : in std_logic;
      d : in std_logic_vector (1 to n);
      q : out std_logic_vector (1 to n)
   );
end posuv_reg;

architecture struct of posuv_reg is
   signal reg : std_logic_vector (1 to n);
begin
   process (clk, n_r)
   begin
      -- realizace asynchronniho nulovani
      if n_r = '0' then
         reg <= (others => '0');
      elsif clk'event and clk = '1' then
         -- realizace synchronniho nastaveni registru
         if pe = '1' then
            reg <= d;
         else
            -- posun registru vpravo a nasunuti novych dat zleva
            reg <= sd & reg (1 to n - 1);
         end if;
      end if;
   end process;
   q <= reg;
end struct;
