-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : johnson.vhd
--   Nazev     : Vypis 9.5
--   Popis     : Johnsonuv citac
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity johnson is
   port (
      reset : in std_logic;
      clk : in std_logic;
      q : out std_logic_vector (0 to 3)
   );
end johnson;

architecture struct of johnson is
   signal reg : std_logic_vector (0 to 3);
begin
   process (reset, clk)
   begin
      -- asynchronni reset
      if reset = '1' then
         reg <= "0000";
      -- realizace Jonhsonova citace
      elsif clk'event and clk = '1' then
         reg <= not reg(3) & reg(0 to 2);
      end if;
   end process;
   q <= reg;
end struct;
