-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : citac.vhd
--   Nazev     : Vypis 9.8
--   Popis     : Synchronni citac vpred s asynchronnim nulovanim a
--               prednastavenim
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity citac is
   generic (
      n : positive := 8
   );
   port (
      clk : in std_logic;
      clr : in std_logic;
      n_ld : in std_logic;
      d : in std_logic_vector (n - 1 downto 0);
      q : out std_logic_vector (n - 1 downto 0)
   );
end citac;

architecture struct of citac is
begin
   -- citac vpred s asynchronnim nulovanim a prednastavenim
   process (clk, clr, n_ld)
      variable cnt : unsigned (n - 1 downto 0);
   begin
      -- asynchronni reset
      if clr = '1' then
         cnt := (others => '0');
      -- asynchronni prednastaveni
      elsif n_ld = '0' then
         cnt := unsigned (d); -- konverze na typ unsigned
      -- synchronni citac
      elsif clk'event and clk = '1' then
         cnt := cnt + 1;
      end if;
      -- konverze na typ std_logic_vector
      q <= std_logic_vector (cnt);
   end process;
end struct;
